#!/usr/bin/env python3

import lhotse

import os

from pathlib import Path


def main():
    filename = "/ceph-fj/fangjun/open-source/icefall-dan-second-giga-libri/egs/librispeech/ASR/data/fbank/gigaspeech_cuts_DEV.jsonl.gz"
    cuts = lhotse.load_manifest(filename)
    d = "/tmp/fangjun"
    n = len(cuts)
    filename = "a.scp"
    with open(filename, "w") as f:
        for i, c in enumerate(cuts):
            if not (4500 < i < 4600):
                continue
            print(f"{i}/{n}")
            if not (Path(d) / f"{c.id}.wav").is_file():
                source = c.recording.sources[0].source
                s = "ffmpeg -hide_banner -i {input} -acodec pcm_s16le -ac 1 -ar 16000 {d}/{id}.wav"

                ret = os.system(s.format(input=source, d=d, id=c.id))
                if ret != 0:
                    raise ValueError(s.format(input=source, id=c.id))

            f.write(f"{c.id} {d}/{c.id}.wav\n")


if __name__ == "__main__":
    main()
