#!/usr/bin/env python3

import lhotse

import os

from pathlib import Path
import threading
import torchaudio
import torch


def run(index):
    filename = "/ceph-fj/fangjun/open-source/icefall-dan-second-giga-libri/egs/librispeech/ASR/data/fbank/gigaspeech_cuts_DEV.jsonl.gz"
    cuts = lhotse.load_manifest(filename)
    d = "/k2-dev/fangjun/data/giga-dev"
    n = len(cuts)
    offset = 5000
    n = 20
    start = offset + index * n
    end = start + n
    sample_rate = 16000
    total = len(cuts)
    for i, c in enumerate(cuts):
        if not (start <= i < end):
            continue
        print(index, i, total)

        filename = Path(d) / f"{c.id}.wav"

        if not filename.is_file():
            waveform = c.load_audio()
            waveform = torch.from_numpy(waveform)
            torchaudio.save(
                str(filename),
                waveform,
                sample_rate,
                encoding="PCM_S",
                bits_per_sample=16,
            )


def main():
    n = 40
    threads = []
    for i in range(n):
        t = threading.Thread(target=run, args=(i,))
        t.start()
        threads.append(t)

    for t in threads:
        t.join()


if __name__ == "__main__":
    main()
